// Read Only Memory Module
// SAW WAVE
/*
x = 1:256;
% Sin : scale to 15-bits
% 2's complement!
y = fix(-1*(2^14 - 1) + ((2*x-1)/256)*(2^14 - 1));
plot(x, y, 'r-');
for i=x
    if y(i)<0
        y(i) = 2^16 + y(i);
    end
    fprintf('\t\t\t8''h%02x: oSaw = 16''h%04x ;\n', x(i)-1 ,y(i))
end
*/
module SyncRomSawTable
(
    iCLK,
    iAddress,
    oSaw
);
    // Inputs
    input iCLK;
    input[7:0] iAddress;
    // Outputs
    output reg[15:0] oSaw;

    always@(posedge iCLK)
    begin
		case(iAddress)
			8'h00: oSaw = 16'hc041 ;
			8'h01: oSaw = 16'hc0c1 ;
			8'h02: oSaw = 16'hc141 ;
			8'h03: oSaw = 16'hc1c1 ;
			8'h04: oSaw = 16'hc241 ;
			8'h05: oSaw = 16'hc2c1 ;
			8'h06: oSaw = 16'hc341 ;
			8'h07: oSaw = 16'hc3c1 ;
			8'h08: oSaw = 16'hc441 ;
			8'h09: oSaw = 16'hc4c1 ;
			8'h0a: oSaw = 16'hc541 ;
			8'h0b: oSaw = 16'hc5c1 ;
			8'h0c: oSaw = 16'hc641 ;
			8'h0d: oSaw = 16'hc6c1 ;
			8'h0e: oSaw = 16'hc741 ;
			8'h0f: oSaw = 16'hc7c1 ;
			8'h10: oSaw = 16'hc841 ;
			8'h11: oSaw = 16'hc8c1 ;
			8'h12: oSaw = 16'hc941 ;
			8'h13: oSaw = 16'hc9c1 ;
			8'h14: oSaw = 16'hca41 ;
			8'h15: oSaw = 16'hcac1 ;
			8'h16: oSaw = 16'hcb41 ;
			8'h17: oSaw = 16'hcbc1 ;
			8'h18: oSaw = 16'hcc41 ;
			8'h19: oSaw = 16'hccc1 ;
			8'h1a: oSaw = 16'hcd41 ;
			8'h1b: oSaw = 16'hcdc1 ;
			8'h1c: oSaw = 16'hce41 ;
			8'h1d: oSaw = 16'hcec1 ;
			8'h1e: oSaw = 16'hcf41 ;
			8'h1f: oSaw = 16'hcfc1 ;
			8'h20: oSaw = 16'hd041 ;
			8'h21: oSaw = 16'hd0c1 ;
			8'h22: oSaw = 16'hd141 ;
			8'h23: oSaw = 16'hd1c1 ;
			8'h24: oSaw = 16'hd241 ;
			8'h25: oSaw = 16'hd2c1 ;
			8'h26: oSaw = 16'hd341 ;
			8'h27: oSaw = 16'hd3c1 ;
			8'h28: oSaw = 16'hd441 ;
			8'h29: oSaw = 16'hd4c1 ;
			8'h2a: oSaw = 16'hd541 ;
			8'h2b: oSaw = 16'hd5c1 ;
			8'h2c: oSaw = 16'hd641 ;
			8'h2d: oSaw = 16'hd6c1 ;
			8'h2e: oSaw = 16'hd741 ;
			8'h2f: oSaw = 16'hd7c1 ;
			8'h30: oSaw = 16'hd841 ;
			8'h31: oSaw = 16'hd8c1 ;
			8'h32: oSaw = 16'hd941 ;
			8'h33: oSaw = 16'hd9c1 ;
			8'h34: oSaw = 16'hda41 ;
			8'h35: oSaw = 16'hdac1 ;
			8'h36: oSaw = 16'hdb41 ;
			8'h37: oSaw = 16'hdbc1 ;
			8'h38: oSaw = 16'hdc41 ;
			8'h39: oSaw = 16'hdcc1 ;
			8'h3a: oSaw = 16'hdd41 ;
			8'h3b: oSaw = 16'hddc1 ;
			8'h3c: oSaw = 16'hde41 ;
			8'h3d: oSaw = 16'hdec1 ;
			8'h3e: oSaw = 16'hdf41 ;
			8'h3f: oSaw = 16'hdfc1 ;
			8'h40: oSaw = 16'he041 ;
			8'h41: oSaw = 16'he0c1 ;
			8'h42: oSaw = 16'he141 ;
			8'h43: oSaw = 16'he1c1 ;
			8'h44: oSaw = 16'he241 ;
			8'h45: oSaw = 16'he2c1 ;
			8'h46: oSaw = 16'he341 ;
			8'h47: oSaw = 16'he3c1 ;
			8'h48: oSaw = 16'he441 ;
			8'h49: oSaw = 16'he4c1 ;
			8'h4a: oSaw = 16'he541 ;
			8'h4b: oSaw = 16'he5c1 ;
			8'h4c: oSaw = 16'he641 ;
			8'h4d: oSaw = 16'he6c1 ;
			8'h4e: oSaw = 16'he741 ;
			8'h4f: oSaw = 16'he7c1 ;
			8'h50: oSaw = 16'he841 ;
			8'h51: oSaw = 16'he8c1 ;
			8'h52: oSaw = 16'he941 ;
			8'h53: oSaw = 16'he9c1 ;
			8'h54: oSaw = 16'hea41 ;
			8'h55: oSaw = 16'heac1 ;
			8'h56: oSaw = 16'heb41 ;
			8'h57: oSaw = 16'hebc1 ;
			8'h58: oSaw = 16'hec41 ;
			8'h59: oSaw = 16'hecc1 ;
			8'h5a: oSaw = 16'hed41 ;
			8'h5b: oSaw = 16'hedc1 ;
			8'h5c: oSaw = 16'hee41 ;
			8'h5d: oSaw = 16'heec1 ;
			8'h5e: oSaw = 16'hef41 ;
			8'h5f: oSaw = 16'hefc1 ;
			8'h60: oSaw = 16'hf041 ;
			8'h61: oSaw = 16'hf0c1 ;
			8'h62: oSaw = 16'hf141 ;
			8'h63: oSaw = 16'hf1c1 ;
			8'h64: oSaw = 16'hf241 ;
			8'h65: oSaw = 16'hf2c1 ;
			8'h66: oSaw = 16'hf341 ;
			8'h67: oSaw = 16'hf3c1 ;
			8'h68: oSaw = 16'hf441 ;
			8'h69: oSaw = 16'hf4c1 ;
			8'h6a: oSaw = 16'hf541 ;
			8'h6b: oSaw = 16'hf5c1 ;
			8'h6c: oSaw = 16'hf641 ;
			8'h6d: oSaw = 16'hf6c1 ;
			8'h6e: oSaw = 16'hf741 ;
			8'h6f: oSaw = 16'hf7c1 ;
			8'h70: oSaw = 16'hf841 ;
			8'h71: oSaw = 16'hf8c1 ;
			8'h72: oSaw = 16'hf941 ;
			8'h73: oSaw = 16'hf9c1 ;
			8'h74: oSaw = 16'hfa41 ;
			8'h75: oSaw = 16'hfac1 ;
			8'h76: oSaw = 16'hfb41 ;
			8'h77: oSaw = 16'hfbc1 ;
			8'h78: oSaw = 16'hfc41 ;
			8'h79: oSaw = 16'hfcc1 ;
			8'h7a: oSaw = 16'hfd41 ;
			8'h7b: oSaw = 16'hfdc1 ;
			8'h7c: oSaw = 16'hfe41 ;
			8'h7d: oSaw = 16'hfec1 ;
			8'h7e: oSaw = 16'hff41 ;
			8'h7f: oSaw = 16'hffc1 ;
			8'h80: oSaw = 16'h003f ;
			8'h81: oSaw = 16'h00bf ;
			8'h82: oSaw = 16'h013f ;
			8'h83: oSaw = 16'h01bf ;
			8'h84: oSaw = 16'h023f ;
			8'h85: oSaw = 16'h02bf ;
			8'h86: oSaw = 16'h033f ;
			8'h87: oSaw = 16'h03bf ;
			8'h88: oSaw = 16'h043f ;
			8'h89: oSaw = 16'h04bf ;
			8'h8a: oSaw = 16'h053f ;
			8'h8b: oSaw = 16'h05bf ;
			8'h8c: oSaw = 16'h063f ;
			8'h8d: oSaw = 16'h06bf ;
			8'h8e: oSaw = 16'h073f ;
			8'h8f: oSaw = 16'h07bf ;
			8'h90: oSaw = 16'h083f ;
			8'h91: oSaw = 16'h08bf ;
			8'h92: oSaw = 16'h093f ;
			8'h93: oSaw = 16'h09bf ;
			8'h94: oSaw = 16'h0a3f ;
			8'h95: oSaw = 16'h0abf ;
			8'h96: oSaw = 16'h0b3f ;
			8'h97: oSaw = 16'h0bbf ;
			8'h98: oSaw = 16'h0c3f ;
			8'h99: oSaw = 16'h0cbf ;
			8'h9a: oSaw = 16'h0d3f ;
			8'h9b: oSaw = 16'h0dbf ;
			8'h9c: oSaw = 16'h0e3f ;
			8'h9d: oSaw = 16'h0ebf ;
			8'h9e: oSaw = 16'h0f3f ;
			8'h9f: oSaw = 16'h0fbf ;
			8'ha0: oSaw = 16'h103f ;
			8'ha1: oSaw = 16'h10bf ;
			8'ha2: oSaw = 16'h113f ;
			8'ha3: oSaw = 16'h11bf ;
			8'ha4: oSaw = 16'h123f ;
			8'ha5: oSaw = 16'h12bf ;
			8'ha6: oSaw = 16'h133f ;
			8'ha7: oSaw = 16'h13bf ;
			8'ha8: oSaw = 16'h143f ;
			8'ha9: oSaw = 16'h14bf ;
			8'haa: oSaw = 16'h153f ;
			8'hab: oSaw = 16'h15bf ;
			8'hac: oSaw = 16'h163f ;
			8'had: oSaw = 16'h16bf ;
			8'hae: oSaw = 16'h173f ;
			8'haf: oSaw = 16'h17bf ;
			8'hb0: oSaw = 16'h183f ;
			8'hb1: oSaw = 16'h18bf ;
			8'hb2: oSaw = 16'h193f ;
			8'hb3: oSaw = 16'h19bf ;
			8'hb4: oSaw = 16'h1a3f ;
			8'hb5: oSaw = 16'h1abf ;
			8'hb6: oSaw = 16'h1b3f ;
			8'hb7: oSaw = 16'h1bbf ;
			8'hb8: oSaw = 16'h1c3f ;
			8'hb9: oSaw = 16'h1cbf ;
			8'hba: oSaw = 16'h1d3f ;
			8'hbb: oSaw = 16'h1dbf ;
			8'hbc: oSaw = 16'h1e3f ;
			8'hbd: oSaw = 16'h1ebf ;
			8'hbe: oSaw = 16'h1f3f ;
			8'hbf: oSaw = 16'h1fbf ;
			8'hc0: oSaw = 16'h203f ;
			8'hc1: oSaw = 16'h20bf ;
			8'hc2: oSaw = 16'h213f ;
			8'hc3: oSaw = 16'h21bf ;
			8'hc4: oSaw = 16'h223f ;
			8'hc5: oSaw = 16'h22bf ;
			8'hc6: oSaw = 16'h233f ;
			8'hc7: oSaw = 16'h23bf ;
			8'hc8: oSaw = 16'h243f ;
			8'hc9: oSaw = 16'h24bf ;
			8'hca: oSaw = 16'h253f ;
			8'hcb: oSaw = 16'h25bf ;
			8'hcc: oSaw = 16'h263f ;
			8'hcd: oSaw = 16'h26bf ;
			8'hce: oSaw = 16'h273f ;
			8'hcf: oSaw = 16'h27bf ;
			8'hd0: oSaw = 16'h283f ;
			8'hd1: oSaw = 16'h28bf ;
			8'hd2: oSaw = 16'h293f ;
			8'hd3: oSaw = 16'h29bf ;
			8'hd4: oSaw = 16'h2a3f ;
			8'hd5: oSaw = 16'h2abf ;
			8'hd6: oSaw = 16'h2b3f ;
			8'hd7: oSaw = 16'h2bbf ;
			8'hd8: oSaw = 16'h2c3f ;
			8'hd9: oSaw = 16'h2cbf ;
			8'hda: oSaw = 16'h2d3f ;
			8'hdb: oSaw = 16'h2dbf ;
			8'hdc: oSaw = 16'h2e3f ;
			8'hdd: oSaw = 16'h2ebf ;
			8'hde: oSaw = 16'h2f3f ;
			8'hdf: oSaw = 16'h2fbf ;
			8'he0: oSaw = 16'h303f ;
			8'he1: oSaw = 16'h30bf ;
			8'he2: oSaw = 16'h313f ;
			8'he3: oSaw = 16'h31bf ;
			8'he4: oSaw = 16'h323f ;
			8'he5: oSaw = 16'h32bf ;
			8'he6: oSaw = 16'h333f ;
			8'he7: oSaw = 16'h33bf ;
			8'he8: oSaw = 16'h343f ;
			8'he9: oSaw = 16'h34bf ;
			8'hea: oSaw = 16'h353f ;
			8'heb: oSaw = 16'h35bf ;
			8'hec: oSaw = 16'h363f ;
			8'hed: oSaw = 16'h36bf ;
			8'hee: oSaw = 16'h373f ;
			8'hef: oSaw = 16'h37bf ;
			8'hf0: oSaw = 16'h383f ;
			8'hf1: oSaw = 16'h38bf ;
			8'hf2: oSaw = 16'h393f ;
			8'hf3: oSaw = 16'h39bf ;
			8'hf4: oSaw = 16'h3a3f ;
			8'hf5: oSaw = 16'h3abf ;
			8'hf6: oSaw = 16'h3b3f ;
			8'hf7: oSaw = 16'h3bbf ;
			8'hf8: oSaw = 16'h3c3f ;
			8'hf9: oSaw = 16'h3cbf ;
			8'hfa: oSaw = 16'h3d3f ;
			8'hfb: oSaw = 16'h3dbf ;
			8'hfc: oSaw = 16'h3e3f ;
			8'hfd: oSaw = 16'h3ebf ;
			8'hfe: oSaw = 16'h3f3f ;
			8'hff: oSaw = 16'h3fbf ;
        endcase
    end
endmodule
