// Read Only Memory Module
// oTriangle WAVE

/*

x = 1:256;
% Sin : scale to 15-bits
% 2's complement!
for i=x
    if i <= 127
        y(i) = fix(-1*(2^14 - 1) + ((4*x(i)-1)/256)*(2^14 - 1));
    elseif i > 127
        y(i) = fix((2^14 - 1) - ((4*x(i - 127)-1)/256)*(2^14 - 1));
    end
end
plot(x, y, 'r-');
for i=x
    if y(i)<0
        y(i) = 2^16 + y(i);
    end
    fprintf('\t\t\t8''h%02x: oSaw = 16''h%04x ;\n', x(i)-1 ,y(i))
end

*/

module SyncRomTriangleTable
(
    iCLK,
    iAddress,
    oTriangle
);
    // Inputs
    input iCLK;
    input[7:0] iAddress;
    // Outputs
    output reg[15:0] oTriangle;

    always@(posedge iCLK)
    begin
		case(iAddress)
			8'h00: oTriangle = 16'hc0c1 ;
			8'h01: oTriangle = 16'hc1c1 ;
			8'h02: oTriangle = 16'hc2c1 ;
			8'h03: oTriangle = 16'hc3c1 ;
			8'h04: oTriangle = 16'hc4c1 ;
			8'h05: oTriangle = 16'hc5c1 ;
			8'h06: oTriangle = 16'hc6c1 ;
			8'h07: oTriangle = 16'hc7c1 ;
			8'h08: oTriangle = 16'hc8c1 ;
			8'h09: oTriangle = 16'hc9c1 ;
			8'h0a: oTriangle = 16'hcac1 ;
			8'h0b: oTriangle = 16'hcbc1 ;
			8'h0c: oTriangle = 16'hccc1 ;
			8'h0d: oTriangle = 16'hcdc1 ;
			8'h0e: oTriangle = 16'hcec1 ;
			8'h0f: oTriangle = 16'hcfc1 ;
			8'h10: oTriangle = 16'hd0c1 ;
			8'h11: oTriangle = 16'hd1c1 ;
			8'h12: oTriangle = 16'hd2c1 ;
			8'h13: oTriangle = 16'hd3c1 ;
			8'h14: oTriangle = 16'hd4c1 ;
			8'h15: oTriangle = 16'hd5c1 ;
			8'h16: oTriangle = 16'hd6c1 ;
			8'h17: oTriangle = 16'hd7c1 ;
			8'h18: oTriangle = 16'hd8c1 ;
			8'h19: oTriangle = 16'hd9c1 ;
			8'h1a: oTriangle = 16'hdac1 ;
			8'h1b: oTriangle = 16'hdbc1 ;
			8'h1c: oTriangle = 16'hdcc1 ;
			8'h1d: oTriangle = 16'hddc1 ;
			8'h1e: oTriangle = 16'hdec1 ;
			8'h1f: oTriangle = 16'hdfc1 ;
			8'h20: oTriangle = 16'he0c1 ;
			8'h21: oTriangle = 16'he1c1 ;
			8'h22: oTriangle = 16'he2c1 ;
			8'h23: oTriangle = 16'he3c1 ;
			8'h24: oTriangle = 16'he4c1 ;
			8'h25: oTriangle = 16'he5c1 ;
			8'h26: oTriangle = 16'he6c1 ;
			8'h27: oTriangle = 16'he7c1 ;
			8'h28: oTriangle = 16'he8c1 ;
			8'h29: oTriangle = 16'he9c1 ;
			8'h2a: oTriangle = 16'heac1 ;
			8'h2b: oTriangle = 16'hebc1 ;
			8'h2c: oTriangle = 16'hecc1 ;
			8'h2d: oTriangle = 16'hedc1 ;
			8'h2e: oTriangle = 16'heec1 ;
			8'h2f: oTriangle = 16'hefc1 ;
			8'h30: oTriangle = 16'hf0c1 ;
			8'h31: oTriangle = 16'hf1c1 ;
			8'h32: oTriangle = 16'hf2c1 ;
			8'h33: oTriangle = 16'hf3c1 ;
			8'h34: oTriangle = 16'hf4c1 ;
			8'h35: oTriangle = 16'hf5c1 ;
			8'h36: oTriangle = 16'hf6c1 ;
			8'h37: oTriangle = 16'hf7c1 ;
			8'h38: oTriangle = 16'hf8c1 ;
			8'h39: oTriangle = 16'hf9c1 ;
			8'h3a: oTriangle = 16'hfac1 ;
			8'h3b: oTriangle = 16'hfbc1 ;
			8'h3c: oTriangle = 16'hfcc1 ;
			8'h3d: oTriangle = 16'hfdc1 ;
			8'h3e: oTriangle = 16'hfec1 ;
			8'h3f: oTriangle = 16'hffc1 ;
			8'h40: oTriangle = 16'h00bf ;
			8'h41: oTriangle = 16'h01bf ;
			8'h42: oTriangle = 16'h02bf ;
			8'h43: oTriangle = 16'h03bf ;
			8'h44: oTriangle = 16'h04bf ;
			8'h45: oTriangle = 16'h05bf ;
			8'h46: oTriangle = 16'h06bf ;
			8'h47: oTriangle = 16'h07bf ;
			8'h48: oTriangle = 16'h08bf ;
			8'h49: oTriangle = 16'h09bf ;
			8'h4a: oTriangle = 16'h0abf ;
			8'h4b: oTriangle = 16'h0bbf ;
			8'h4c: oTriangle = 16'h0cbf ;
			8'h4d: oTriangle = 16'h0dbf ;
			8'h4e: oTriangle = 16'h0ebf ;
			8'h4f: oTriangle = 16'h0fbf ;
			8'h50: oTriangle = 16'h10bf ;
			8'h51: oTriangle = 16'h11bf ;
			8'h52: oTriangle = 16'h12bf ;
			8'h53: oTriangle = 16'h13bf ;
			8'h54: oTriangle = 16'h14bf ;
			8'h55: oTriangle = 16'h15bf ;
			8'h56: oTriangle = 16'h16bf ;
			8'h57: oTriangle = 16'h17bf ;
			8'h58: oTriangle = 16'h18bf ;
			8'h59: oTriangle = 16'h19bf ;
			8'h5a: oTriangle = 16'h1abf ;
			8'h5b: oTriangle = 16'h1bbf ;
			8'h5c: oTriangle = 16'h1cbf ;
			8'h5d: oTriangle = 16'h1dbf ;
			8'h5e: oTriangle = 16'h1ebf ;
			8'h5f: oTriangle = 16'h1fbf ;
			8'h60: oTriangle = 16'h20bf ;
			8'h61: oTriangle = 16'h21bf ;
			8'h62: oTriangle = 16'h22bf ;
			8'h63: oTriangle = 16'h23bf ;
			8'h64: oTriangle = 16'h24bf ;
			8'h65: oTriangle = 16'h25bf ;
			8'h66: oTriangle = 16'h26bf ;
			8'h67: oTriangle = 16'h27bf ;
			8'h68: oTriangle = 16'h28bf ;
			8'h69: oTriangle = 16'h29bf ;
			8'h6a: oTriangle = 16'h2abf ;
			8'h6b: oTriangle = 16'h2bbf ;
			8'h6c: oTriangle = 16'h2cbf ;
			8'h6d: oTriangle = 16'h2dbf ;
			8'h6e: oTriangle = 16'h2ebf ;
			8'h6f: oTriangle = 16'h2fbf ;
			8'h70: oTriangle = 16'h30bf ;
			8'h71: oTriangle = 16'h31bf ;
			8'h72: oTriangle = 16'h32bf ;
			8'h73: oTriangle = 16'h33bf ;
			8'h74: oTriangle = 16'h34bf ;
			8'h75: oTriangle = 16'h35bf ;
			8'h76: oTriangle = 16'h36bf ;
			8'h77: oTriangle = 16'h37bf ;
			8'h78: oTriangle = 16'h38bf ;
			8'h79: oTriangle = 16'h39bf ;
			8'h7a: oTriangle = 16'h3abf ;
			8'h7b: oTriangle = 16'h3bbf ;
			8'h7c: oTriangle = 16'h3cbf ;
			8'h7d: oTriangle = 16'h3dbf ;
			8'h7e: oTriangle = 16'h3ebf ;
			8'h7f: oTriangle = 16'h3f3f ;
			8'h80: oTriangle = 16'h3e3f ;
			8'h81: oTriangle = 16'h3d3f ;
			8'h82: oTriangle = 16'h3c3f ;
			8'h83: oTriangle = 16'h3b3f ;
			8'h84: oTriangle = 16'h3a3f ;
			8'h85: oTriangle = 16'h393f ;
			8'h86: oTriangle = 16'h383f ;
			8'h87: oTriangle = 16'h373f ;
			8'h88: oTriangle = 16'h363f ;
			8'h89: oTriangle = 16'h353f ;
			8'h8a: oTriangle = 16'h343f ;
			8'h8b: oTriangle = 16'h333f ;
			8'h8c: oTriangle = 16'h323f ;
			8'h8d: oTriangle = 16'h313f ;
			8'h8e: oTriangle = 16'h303f ;
			8'h8f: oTriangle = 16'h2f3f ;
			8'h90: oTriangle = 16'h2e3f ;
			8'h91: oTriangle = 16'h2d3f ;
			8'h92: oTriangle = 16'h2c3f ;
			8'h93: oTriangle = 16'h2b3f ;
			8'h94: oTriangle = 16'h2a3f ;
			8'h95: oTriangle = 16'h293f ;
			8'h96: oTriangle = 16'h283f ;
			8'h97: oTriangle = 16'h273f ;
			8'h98: oTriangle = 16'h263f ;
			8'h99: oTriangle = 16'h253f ;
			8'h9a: oTriangle = 16'h243f ;
			8'h9b: oTriangle = 16'h233f ;
			8'h9c: oTriangle = 16'h223f ;
			8'h9d: oTriangle = 16'h213f ;
			8'h9e: oTriangle = 16'h203f ;
			8'h9f: oTriangle = 16'h1f3f ;
			8'ha0: oTriangle = 16'h1e3f ;
			8'ha1: oTriangle = 16'h1d3f ;
			8'ha2: oTriangle = 16'h1c3f ;
			8'ha3: oTriangle = 16'h1b3f ;
			8'ha4: oTriangle = 16'h1a3f ;
			8'ha5: oTriangle = 16'h193f ;
			8'ha6: oTriangle = 16'h183f ;
			8'ha7: oTriangle = 16'h173f ;
			8'ha8: oTriangle = 16'h163f ;
			8'ha9: oTriangle = 16'h153f ;
			8'haa: oTriangle = 16'h143f ;
			8'hab: oTriangle = 16'h133f ;
			8'hac: oTriangle = 16'h123f ;
			8'had: oTriangle = 16'h113f ;
			8'hae: oTriangle = 16'h103f ;
			8'haf: oTriangle = 16'h0f3f ;
			8'hb0: oTriangle = 16'h0e3f ;
			8'hb1: oTriangle = 16'h0d3f ;
			8'hb2: oTriangle = 16'h0c3f ;
			8'hb3: oTriangle = 16'h0b3f ;
			8'hb4: oTriangle = 16'h0a3f ;
			8'hb5: oTriangle = 16'h093f ;
			8'hb6: oTriangle = 16'h083f ;
			8'hb7: oTriangle = 16'h073f ;
			8'hb8: oTriangle = 16'h063f ;
			8'hb9: oTriangle = 16'h053f ;
			8'hba: oTriangle = 16'h043f ;
			8'hbb: oTriangle = 16'h033f ;
			8'hbc: oTriangle = 16'h023f ;
			8'hbd: oTriangle = 16'h013f ;
			8'hbe: oTriangle = 16'h003f ;
			8'hbf: oTriangle = 16'hff41 ;
			8'hc0: oTriangle = 16'hfe41 ;
			8'hc1: oTriangle = 16'hfd41 ;
			8'hc2: oTriangle = 16'hfc41 ;
			8'hc3: oTriangle = 16'hfb41 ;
			8'hc4: oTriangle = 16'hfa41 ;
			8'hc5: oTriangle = 16'hf941 ;
			8'hc6: oTriangle = 16'hf841 ;
			8'hc7: oTriangle = 16'hf741 ;
			8'hc8: oTriangle = 16'hf641 ;
			8'hc9: oTriangle = 16'hf541 ;
			8'hca: oTriangle = 16'hf441 ;
			8'hcb: oTriangle = 16'hf341 ;
			8'hcc: oTriangle = 16'hf241 ;
			8'hcd: oTriangle = 16'hf141 ;
			8'hce: oTriangle = 16'hf041 ;
			8'hcf: oTriangle = 16'hef41 ;
			8'hd0: oTriangle = 16'hee41 ;
			8'hd1: oTriangle = 16'hed41 ;
			8'hd2: oTriangle = 16'hec41 ;
			8'hd3: oTriangle = 16'heb41 ;
			8'hd4: oTriangle = 16'hea41 ;
			8'hd5: oTriangle = 16'he941 ;
			8'hd6: oTriangle = 16'he841 ;
			8'hd7: oTriangle = 16'he741 ;
			8'hd8: oTriangle = 16'he641 ;
			8'hd9: oTriangle = 16'he541 ;
			8'hda: oTriangle = 16'he441 ;
			8'hdb: oTriangle = 16'he341 ;
			8'hdc: oTriangle = 16'he241 ;
			8'hdd: oTriangle = 16'he141 ;
			8'hde: oTriangle = 16'he041 ;
			8'hdf: oTriangle = 16'hdf41 ;
			8'he0: oTriangle = 16'hde41 ;
			8'he1: oTriangle = 16'hdd41 ;
			8'he2: oTriangle = 16'hdc41 ;
			8'he3: oTriangle = 16'hdb41 ;
			8'he4: oTriangle = 16'hda41 ;
			8'he5: oTriangle = 16'hd941 ;
			8'he6: oTriangle = 16'hd841 ;
			8'he7: oTriangle = 16'hd741 ;
			8'he8: oTriangle = 16'hd641 ;
			8'he9: oTriangle = 16'hd541 ;
			8'hea: oTriangle = 16'hd441 ;
			8'heb: oTriangle = 16'hd341 ;
			8'hec: oTriangle = 16'hd241 ;
			8'hed: oTriangle = 16'hd141 ;
			8'hee: oTriangle = 16'hd041 ;
			8'hef: oTriangle = 16'hcf41 ;
			8'hf0: oTriangle = 16'hce41 ;
			8'hf1: oTriangle = 16'hcd41 ;
			8'hf2: oTriangle = 16'hcc41 ;
			8'hf3: oTriangle = 16'hcb41 ;
			8'hf4: oTriangle = 16'hca41 ;
			8'hf5: oTriangle = 16'hc941 ;
			8'hf6: oTriangle = 16'hc841 ;
			8'hf7: oTriangle = 16'hc741 ;
			8'hf8: oTriangle = 16'hc641 ;
			8'hf9: oTriangle = 16'hc541 ;
			8'hfa: oTriangle = 16'hc441 ;
			8'hfb: oTriangle = 16'hc341 ;
			8'hfc: oTriangle = 16'hc241 ;
			8'hfd: oTriangle = 16'hc141 ;
			8'hfe: oTriangle = 16'hc041 ;
			8'hff: oTriangle = 16'hbf42 ;
			8'h00: oTriangle = 16'hc0c1 ;
			8'h01: oTriangle = 16'hc1c1 ;
			8'h02: oTriangle = 16'hc2c1 ;
			8'h03: oTriangle = 16'hc3c1 ;
			8'h04: oTriangle = 16'hc4c1 ;
			8'h05: oTriangle = 16'hc5c1 ;
			8'h06: oTriangle = 16'hc6c1 ;
			8'h07: oTriangle = 16'hc7c1 ;
			8'h08: oTriangle = 16'hc8c1 ;
			8'h09: oTriangle = 16'hc9c1 ;
			8'h0a: oTriangle = 16'hcac1 ;
			8'h0b: oTriangle = 16'hcbc1 ;
			8'h0c: oTriangle = 16'hccc1 ;
			8'h0d: oTriangle = 16'hcdc1 ;
			8'h0e: oTriangle = 16'hcec1 ;
			8'h0f: oTriangle = 16'hcfc1 ;
			8'h10: oTriangle = 16'hd0c1 ;
			8'h11: oTriangle = 16'hd1c1 ;
			8'h12: oTriangle = 16'hd2c1 ;
			8'h13: oTriangle = 16'hd3c1 ;
			8'h14: oTriangle = 16'hd4c1 ;
			8'h15: oTriangle = 16'hd5c1 ;
			8'h16: oTriangle = 16'hd6c1 ;
			8'h17: oTriangle = 16'hd7c1 ;
			8'h18: oTriangle = 16'hd8c1 ;
			8'h19: oTriangle = 16'hd9c1 ;
			8'h1a: oTriangle = 16'hdac1 ;
			8'h1b: oTriangle = 16'hdbc1 ;
			8'h1c: oTriangle = 16'hdcc1 ;
			8'h1d: oTriangle = 16'hddc1 ;
			8'h1e: oTriangle = 16'hdec1 ;
			8'h1f: oTriangle = 16'hdfc1 ;
			8'h20: oTriangle = 16'he0c1 ;
			8'h21: oTriangle = 16'he1c1 ;
			8'h22: oTriangle = 16'he2c1 ;
			8'h23: oTriangle = 16'he3c1 ;
			8'h24: oTriangle = 16'he4c1 ;
			8'h25: oTriangle = 16'he5c1 ;
			8'h26: oTriangle = 16'he6c1 ;
			8'h27: oTriangle = 16'he7c1 ;
			8'h28: oTriangle = 16'he8c1 ;
			8'h29: oTriangle = 16'he9c1 ;
			8'h2a: oTriangle = 16'heac1 ;
			8'h2b: oTriangle = 16'hebc1 ;
			8'h2c: oTriangle = 16'hecc1 ;
			8'h2d: oTriangle = 16'hedc1 ;
			8'h2e: oTriangle = 16'heec1 ;
			8'h2f: oTriangle = 16'hefc1 ;
			8'h30: oTriangle = 16'hf0c1 ;
			8'h31: oTriangle = 16'hf1c1 ;
			8'h32: oTriangle = 16'hf2c1 ;
			8'h33: oTriangle = 16'hf3c1 ;
			8'h34: oTriangle = 16'hf4c1 ;
			8'h35: oTriangle = 16'hf5c1 ;
			8'h36: oTriangle = 16'hf6c1 ;
			8'h37: oTriangle = 16'hf7c1 ;
			8'h38: oTriangle = 16'hf8c1 ;
			8'h39: oTriangle = 16'hf9c1 ;
			8'h3a: oTriangle = 16'hfac1 ;
			8'h3b: oTriangle = 16'hfbc1 ;
			8'h3c: oTriangle = 16'hfcc1 ;
			8'h3d: oTriangle = 16'hfdc1 ;
			8'h3e: oTriangle = 16'hfec1 ;
			8'h3f: oTriangle = 16'hffc1 ;
			8'h40: oTriangle = 16'h00bf ;
			8'h41: oTriangle = 16'h01bf ;
			8'h42: oTriangle = 16'h02bf ;
			8'h43: oTriangle = 16'h03bf ;
			8'h44: oTriangle = 16'h04bf ;
			8'h45: oTriangle = 16'h05bf ;
			8'h46: oTriangle = 16'h06bf ;
			8'h47: oTriangle = 16'h07bf ;
			8'h48: oTriangle = 16'h08bf ;
			8'h49: oTriangle = 16'h09bf ;
			8'h4a: oTriangle = 16'h0abf ;
			8'h4b: oTriangle = 16'h0bbf ;
			8'h4c: oTriangle = 16'h0cbf ;
			8'h4d: oTriangle = 16'h0dbf ;
			8'h4e: oTriangle = 16'h0ebf ;
			8'h4f: oTriangle = 16'h0fbf ;
			8'h50: oTriangle = 16'h10bf ;
			8'h51: oTriangle = 16'h11bf ;
			8'h52: oTriangle = 16'h12bf ;
			8'h53: oTriangle = 16'h13bf ;
			8'h54: oTriangle = 16'h14bf ;
			8'h55: oTriangle = 16'h15bf ;
			8'h56: oTriangle = 16'h16bf ;
			8'h57: oTriangle = 16'h17bf ;
			8'h58: oTriangle = 16'h18bf ;
			8'h59: oTriangle = 16'h19bf ;
			8'h5a: oTriangle = 16'h1abf ;
			8'h5b: oTriangle = 16'h1bbf ;
			8'h5c: oTriangle = 16'h1cbf ;
			8'h5d: oTriangle = 16'h1dbf ;
			8'h5e: oTriangle = 16'h1ebf ;
			8'h5f: oTriangle = 16'h1fbf ;
			8'h60: oTriangle = 16'h20bf ;
			8'h61: oTriangle = 16'h21bf ;
			8'h62: oTriangle = 16'h22bf ;
			8'h63: oTriangle = 16'h23bf ;
			8'h64: oTriangle = 16'h24bf ;
			8'h65: oTriangle = 16'h25bf ;
			8'h66: oTriangle = 16'h26bf ;
			8'h67: oTriangle = 16'h27bf ;
			8'h68: oTriangle = 16'h28bf ;
			8'h69: oTriangle = 16'h29bf ;
			8'h6a: oTriangle = 16'h2abf ;
			8'h6b: oTriangle = 16'h2bbf ;
			8'h6c: oTriangle = 16'h2cbf ;
			8'h6d: oTriangle = 16'h2dbf ;
			8'h6e: oTriangle = 16'h2ebf ;
			8'h6f: oTriangle = 16'h2fbf ;
			8'h70: oTriangle = 16'h30bf ;
			8'h71: oTriangle = 16'h31bf ;
			8'h72: oTriangle = 16'h32bf ;
			8'h73: oTriangle = 16'h33bf ;
			8'h74: oTriangle = 16'h34bf ;
			8'h75: oTriangle = 16'h35bf ;
			8'h76: oTriangle = 16'h36bf ;
			8'h77: oTriangle = 16'h37bf ;
			8'h78: oTriangle = 16'h38bf ;
			8'h79: oTriangle = 16'h39bf ;
			8'h7a: oTriangle = 16'h3abf ;
			8'h7b: oTriangle = 16'h3bbf ;
			8'h7c: oTriangle = 16'h3cbf ;
			8'h7d: oTriangle = 16'h3dbf ;
			8'h7e: oTriangle = 16'h3ebf ;
			8'h7f: oTriangle = 16'h3f3f ;
			8'h80: oTriangle = 16'h3e3f ;
			8'h81: oTriangle = 16'h3d3f ;
			8'h82: oTriangle = 16'h3c3f ;
			8'h83: oTriangle = 16'h3b3f ;
			8'h84: oTriangle = 16'h3a3f ;
			8'h85: oTriangle = 16'h393f ;
			8'h86: oTriangle = 16'h383f ;
			8'h87: oTriangle = 16'h373f ;
			8'h88: oTriangle = 16'h363f ;
			8'h89: oTriangle = 16'h353f ;
			8'h8a: oTriangle = 16'h343f ;
			8'h8b: oTriangle = 16'h333f ;
			8'h8c: oTriangle = 16'h323f ;
			8'h8d: oTriangle = 16'h313f ;
			8'h8e: oTriangle = 16'h303f ;
			8'h8f: oTriangle = 16'h2f3f ;
			8'h90: oTriangle = 16'h2e3f ;
			8'h91: oTriangle = 16'h2d3f ;
			8'h92: oTriangle = 16'h2c3f ;
			8'h93: oTriangle = 16'h2b3f ;
			8'h94: oTriangle = 16'h2a3f ;
			8'h95: oTriangle = 16'h293f ;
			8'h96: oTriangle = 16'h283f ;
			8'h97: oTriangle = 16'h273f ;
			8'h98: oTriangle = 16'h263f ;
			8'h99: oTriangle = 16'h253f ;
			8'h9a: oTriangle = 16'h243f ;
			8'h9b: oTriangle = 16'h233f ;
			8'h9c: oTriangle = 16'h223f ;
			8'h9d: oTriangle = 16'h213f ;
			8'h9e: oTriangle = 16'h203f ;
			8'h9f: oTriangle = 16'h1f3f ;
			8'ha0: oTriangle = 16'h1e3f ;
			8'ha1: oTriangle = 16'h1d3f ;
			8'ha2: oTriangle = 16'h1c3f ;
			8'ha3: oTriangle = 16'h1b3f ;
			8'ha4: oTriangle = 16'h1a3f ;
			8'ha5: oTriangle = 16'h193f ;
			8'ha6: oTriangle = 16'h183f ;
			8'ha7: oTriangle = 16'h173f ;
			8'ha8: oTriangle = 16'h163f ;
			8'ha9: oTriangle = 16'h153f ;
			8'haa: oTriangle = 16'h143f ;
			8'hab: oTriangle = 16'h133f ;
			8'hac: oTriangle = 16'h123f ;
			8'had: oTriangle = 16'h113f ;
			8'hae: oTriangle = 16'h103f ;
			8'haf: oTriangle = 16'h0f3f ;
			8'hb0: oTriangle = 16'h0e3f ;
			8'hb1: oTriangle = 16'h0d3f ;
			8'hb2: oTriangle = 16'h0c3f ;
			8'hb3: oTriangle = 16'h0b3f ;
			8'hb4: oTriangle = 16'h0a3f ;
			8'hb5: oTriangle = 16'h093f ;
			8'hb6: oTriangle = 16'h083f ;
			8'hb7: oTriangle = 16'h073f ;
			8'hb8: oTriangle = 16'h063f ;
			8'hb9: oTriangle = 16'h053f ;
			8'hba: oTriangle = 16'h043f ;
			8'hbb: oTriangle = 16'h033f ;
			8'hbc: oTriangle = 16'h023f ;
			8'hbd: oTriangle = 16'h013f ;
			8'hbe: oTriangle = 16'h003f ;
			8'hbf: oTriangle = 16'hff41 ;
			8'hc0: oTriangle = 16'hfe41 ;
			8'hc1: oTriangle = 16'hfd41 ;
			8'hc2: oTriangle = 16'hfc41 ;
			8'hc3: oTriangle = 16'hfb41 ;
			8'hc4: oTriangle = 16'hfa41 ;
			8'hc5: oTriangle = 16'hf941 ;
			8'hc6: oTriangle = 16'hf841 ;
			8'hc7: oTriangle = 16'hf741 ;
			8'hc8: oTriangle = 16'hf641 ;
			8'hc9: oTriangle = 16'hf541 ;
			8'hca: oTriangle = 16'hf441 ;
			8'hcb: oTriangle = 16'hf341 ;
			8'hcc: oTriangle = 16'hf241 ;
			8'hcd: oTriangle = 16'hf141 ;
			8'hce: oTriangle = 16'hf041 ;
			8'hcf: oTriangle = 16'hef41 ;
			8'hd0: oTriangle = 16'hee41 ;
			8'hd1: oTriangle = 16'hed41 ;
			8'hd2: oTriangle = 16'hec41 ;
			8'hd3: oTriangle = 16'heb41 ;
			8'hd4: oTriangle = 16'hea41 ;
			8'hd5: oTriangle = 16'he941 ;
			8'hd6: oTriangle = 16'he841 ;
			8'hd7: oTriangle = 16'he741 ;
			8'hd8: oTriangle = 16'he641 ;
			8'hd9: oTriangle = 16'he541 ;
			8'hda: oTriangle = 16'he441 ;
			8'hdb: oTriangle = 16'he341 ;
			8'hdc: oTriangle = 16'he241 ;
			8'hdd: oTriangle = 16'he141 ;
			8'hde: oTriangle = 16'he041 ;
			8'hdf: oTriangle = 16'hdf41 ;
			8'he0: oTriangle = 16'hde41 ;
			8'he1: oTriangle = 16'hdd41 ;
			8'he2: oTriangle = 16'hdc41 ;
			8'he3: oTriangle = 16'hdb41 ;
			8'he4: oTriangle = 16'hda41 ;
			8'he5: oTriangle = 16'hd941 ;
			8'he6: oTriangle = 16'hd841 ;
			8'he7: oTriangle = 16'hd741 ;
			8'he8: oTriangle = 16'hd641 ;
			8'he9: oTriangle = 16'hd541 ;
			8'hea: oTriangle = 16'hd441 ;
			8'heb: oTriangle = 16'hd341 ;
			8'hec: oTriangle = 16'hd241 ;
			8'hed: oTriangle = 16'hd141 ;
			8'hee: oTriangle = 16'hd041 ;
			8'hef: oTriangle = 16'hcf41 ;
			8'hf0: oTriangle = 16'hce41 ;
			8'hf1: oTriangle = 16'hcd41 ;
			8'hf2: oTriangle = 16'hcc41 ;
			8'hf3: oTriangle = 16'hcb41 ;
			8'hf4: oTriangle = 16'hca41 ;
			8'hf5: oTriangle = 16'hc941 ;
			8'hf6: oTriangle = 16'hc841 ;
			8'hf7: oTriangle = 16'hc741 ;
			8'hf8: oTriangle = 16'hc641 ;
			8'hf9: oTriangle = 16'hc541 ;
			8'hfa: oTriangle = 16'hc441 ;
			8'hfb: oTriangle = 16'hc341 ;
			8'hfc: oTriangle = 16'hc241 ;
			8'hfd: oTriangle = 16'hc141 ;
			8'hfe: oTriangle = 16'hc041 ;
			8'hff: oTriangle = 16'hbf42 ;
		endcase
    end
endmodule

