// This is the network hardware controller.
// This is simpler to do this way rather than complicate the operation
// of the ALU and surrounding hardware

// Mainly drives the send and ID commands

`include "ndmaref.h"

module NetCNTL
(
    CLK, Iin, Imm, RT_in,
    dxFlag, dest_id, send_data,
    self_id, idFlag
);

input   wire            CLK;
input   wire    [31:0]  Iin;
input   wire    [31:0]  Imm;
input   wire    [31:0]  RT_in;

output  reg             dxFlag;
output  reg     [7:0]   dest_id;
output  reg     [7:0]   send_data;

output  wire    [7:0]   self_id;
output  reg             idFlag;

assign self_id	 = Imm[7:0];

// self id
always @(negedge CLK) begin
	case ({Iin[`op]})
		{`SID}:
		    begin
			    idFlag <= 1;
				$display("set id: %d", self_id);
			end

		default:    idFlag <= 0;
	endcase
end

// dxFlag
always @(negedge CLK) begin
	case ({Iin[`op]})
		{`SMSG}:
		    begin
		        dxFlag <= 1;
                send_data <= Imm[7:0];
                dest_id <= RT_in[7:0];
            end

		default:
		    begin
		        dxFlag <= 0;
                // likely optional but nice for debugging
                send_data <= 0;
                dest_id <= 0;
            end
	endcase
end

endmodule
