// this module simply comapres two 32 bit
// inputs for equality then sets

// Add functionality for less than
//                       less than equal
//                       greater than
//                       greater than equal
module QC
(
    CLK, MRST,
    Ins, A, B,
    QC_out
);

input   wire            CLK;
input   wire            MRST;
input   wire    [31:0]  Ins;
input   wire    [31:0]  A;
input   wire    [31:0]  B;

output  wire            QC_out;

assign QC_out = (Ins[`op] == `BGTZ) ? (A[31] != 1) :
                (Ins[`op] == `BGEZ) ? (A[31] != 1 || A == 0) :
                (Ins[`op] == `BLTZ) ? (A[31] == 1) :
                (Ins[`op] == `BLEZ) ? (A[31] == 1 || A == 0) : (A == B);

always@(A or B or Ins) begin
    //if(Ins[`op] == `BGTZ) $display("BGTZ A:%b B:%b QC_out:%b", A, B, QC_out);
end

endmodule
