module mem
(
    CLK, MRST,
    // Instruction Memory
    iAddr, Iout, iIData, iIWrite, iIWAddr,
    // Data Memory
    dAddr, dWrite, Din, Dout
);

input   wire            CLK;
input   wire            MRST;

// Instruction Memory
input   wire    [31:0]  iAddr;
output  wire    [31:0]  Iout;
input   wire    [31:0]  iIWAddr;
input   wire    [31:0]  iIData;
input   wire            iIWrite;

// Data Memory
input   wire    [31:0]  dAddr;
input   wire            dWrite;
input   wire    [31:0]  Din;
output  wire    [31:0]  Dout;

integer i;

// default memfile
parameter pIMEM_FILE = "mem.mem";

// these will eventually be replaced with real
// FPGA memories using M4K blocks
reg [31:0] imem [255:0];
reg [31:0] dmem [255:0];

initial begin

end

assign Iout = imem[iAddr];
assign Dout = (dWrite) ? 32'hzzzzzzzz : dmem[dAddr];

//always @(dAddr or dWrite or Din) begin
always @(negedge CLK) begin
    if(MRST)
        begin
            	for(i = 0; i < 256; i = i + 1)
	            begin
	                dmem[i] = 0;
                end
                $readmemb(pIMEM_FILE, imem);
        end
    else
        begin
            if(iIWrite)
                begin
                    imem[iIWAddr] <= iIData;
                    $display("Instruction Mem: Wrote: %d at %d", iIData, iIWAddr);
                end
	        // Data Memory
	        if(dWrite)
	        	begin
	        	    dmem[dAddr] <= Din;
	        	    $display("Data Mem: Wrote: %d at %d", Din, dAddr);
                end
        end
end

endmodule
