// The

module net_mem_ctrl
(
    iCLK, iMRST,
    iNetIns, iNetInsValid,
    oWAddr, oWData, oWrite
);

input   wire            iCLK;
input   wire            iMRST;
input   wire    [31:0]  iNetIns;
input   wire            iNetInsValid;

output  reg     [31:0]  oWAddr;
output  reg     [31:0]  oWData;
output  reg             oWrite;


always@(posedge iCLK) begin
    if(iMRST)
        begin
            oWAddr <= `NET_MEM_START;
            oWData <= 0;
        end
    else
        begin
            if(iNetInsValid)
                begin
                    // if iNetIns != reset / interrupt
                    oWData <= iNetIns;
                    oWrite <= 1;
                end
            else
                begin
                    if(oWrite)
                        begin
                            oWrite <= 0;
                            oWAddr <= oWAddr + 1;
                        end
                end
        end
end

endmodule
