`include "NLayer.v"
`include "mipsref.h"

module TOP;
reg CLK, reset;

reg dxFlag0;
reg [7:0] dest_ID0;
reg [7:0] send_data0;
wire rxFlag0;

reg dxFlag1;
reg [7:0] dest_ID1;
reg [7:0] send_data1;
wire rxFlag1;

reg dxFlag2;
reg [7:0] dest_ID2;
reg [7:0] send_data2;
wire rxFlag2;

reg dxFlag3;
reg [7:0] dest_ID3;
reg [7:0] send_data3;
wire rxFlag3;

reg dxFlag4;
reg [7:0] dest_ID4;
reg [7:0] send_data4;
wire rxFlag4;

reg dxFlag5;
reg [7:0] dest_ID5;
reg [7:0] send_data5;
wire rxFlag5;

reg dxFlag6;
reg [7:0] dest_ID6;
reg [7:0] send_data6;
wire rxFlag6;

reg dxFlag7;
reg [7:0] dest_ID7;
reg [7:0] send_data7;
wire rxFlag7;

reg dxFlag8;
reg [7:0] dest_ID8;
reg [7:0] send_data8;
wire rxFlag8;

reg idFlag = 0;

// only the left and top connects as registers

// node 0 id: 1
reg [31:0] nBusIn0;
reg [31:0] wBusIn0;
wire [31:0] sBusIn0;
wire [31:0] eBusIn0;
wire [31:0] nBusOut0;
wire [31:0] sBusOut0;
wire [31:0] eBusOut0;
wire [31:0] wBusOut0;
reg [7:0] id0 = 1;

// node 1 id: 2
wire [31:0] nBusIn1;
wire [31:0] wBusIn1;
wire [31:0] sBusIn1;
wire [31:0] eBusIn1;
wire [31:0] nBusOut1;
wire [31:0] sBusOut1;
wire [31:0] eBusOut1;
wire [31:0] wBusOut1;
reg [7:0] id1 = 2;

// node 2 id: 3
wire [31:0] nBusIn2;
wire [31:0] wBusIn2;
wire [31:0] sBusIn2;
wire [31:0] eBusIn2;
wire [31:0] nBusOut2;
wire [31:0] sBusOut2;
wire [31:0] eBusOut2;
wire [31:0] wBusOut2;
reg [7:0] id2 = 3;

// node 3 id: 4
wire [31:0] nBusIn3;
wire [31:0] wBusIn3;
wire [31:0] sBusIn3;
wire [31:0] eBusIn3;
wire [31:0] nBusOut3;
wire [31:0] sBusOut3;
wire [31:0] eBusOut3;
wire [31:0] wBusOut3;
reg [7:0] id3 = 4;

// node 4 id: 5
wire [31:0] nBusIn4;
wire [31:0] wBusIn4;
wire [31:0] sBusIn4;
wire [31:0] eBusIn4;
wire [31:0] nBusOut4;
wire [31:0] sBusOut4;
wire [31:0] eBusOut4;
wire [31:0] wBusOut4;
reg [7:0] id4 = 5;

// node 5 id: 6
wire [31:0] nBusIn5;
wire [31:0] wBusIn5;
wire [31:0] sBusIn5;
wire [31:0] eBusIn5;
wire [31:0] nBusOut5;
wire [31:0] sBusOut5;
wire [31:0] eBusOut5;
wire [31:0] wBusOut5;
reg [7:0] id5 = 6;

// node 6 id: 7
wire [31:0] nBusIn6;
wire [31:0] wBusIn6;
wire [31:0] sBusIn6;
wire [31:0] eBusIn6;
wire [31:0] nBusOut6;
wire [31:0] sBusOut6;
wire [31:0] eBusOut6;
wire [31:0] wBusOut6;
reg [7:0] id6 = 7;

// node 7 id: 8
wire [31:0] nBusIn7;
wire [31:0] wBusIn7;
wire [31:0] sBusIn7;
wire [31:0] eBusIn7;
wire [31:0] nBusOut7;
wire [31:0] sBusOut7;
wire [31:0] eBusOut7;
wire [31:0] wBusOut7;
reg [7:0] id7 = 8;

// node 8 id: 9
wire [31:0] nBusIn8;
wire [31:0] wBusIn8;
wire [31:0] sBusIn8;
wire [31:0] eBusIn8;
wire [31:0] nBusOut8;
wire [31:0] sBusOut8;
wire [31:0] eBusOut8;
wire [31:0] wBusOut8;
reg [7:0] id8 = 9;

reg [31:0] timer0 = 0;

initial begin
	CLK = 0;
	reset = 1;
	dxFlag0 = 0;
	dxFlag1 = 0;
	dxFlag2 = 0;
	dxFlag3 = 0;
	dxFlag4 = 0;
	dxFlag5 = 0;
	dxFlag6 = 0;
	dxFlag7 = 0;
	dxFlag8 = 0;
	
	// assign ids
	#10 idFlag <= 1;
	#20 idFlag <= 0;
	
	
	#20 reset = 0;
	
	
	#45 begin
			dest_ID0 <= 9;
			send_data0 <= 5;	
			
			//dest_ID8 <= 1;
			//send_data8 <= 55;
		end
	#50	dxFlag0 <= 1;
	#70 dxFlag0 <= 0;
	
	#80 send_data0 <= 10;
	
	#90 dxFlag0 <= 1;
	#110 dxFlag0 <= 0;
	
	#120 send_data0 <= 15;
	
	#130 dxFlag0 <= 1;
	#150 dxFlag0 <= 0;
	
	#160 send_data0 <= 20;
	
	#170 dxFlag0 <= 1;
	#190 dxFlag0 <= 0;
	
	#200 send_data0 <= 25;
	
	#210 dxFlag0 <= 1;
	#230 dxFlag0 <= 0;
	
	#240 send_data0 <= 30;
	
	#250 dxFlag0 <= 1;
	#270 dxFlag0 <= 0;
	
	#280 send_data0 <= 35;
	
	#290 dxFlag0 <= 1;
	#310 dxFlag0 <= 0;
	
	//$display("%b", test_msg);
	
	#350 $finish;
end

always begin
	#5 CLK <= !CLK;
end

always @(posedge CLK) begin
	timer0 = timer0 + 1;
end


// debugging 
///* 
always @(dxFlag0) if(!reset && dxFlag0) $display("dxFlag0: %d t: %d", dxFlag0, timer0);
always @(dxFlag1) if(!reset && dxFlag1) $display("dxFlag1: %d t: %d", dxFlag1, timer0);
always @(dxFlag2) if(!reset && dxFlag2) $display("dxFlag2: %d t: %d", dxFlag2, timer0);
always @(dxFlag3) if(!reset && dxFlag3) $display("dxFlag3: %d t: %d", dxFlag3, timer0);
always @(dxFlag4) if(!reset && dxFlag4) $display("dxFlag4: %d t: %d", dxFlag4, timer0);
always @(dxFlag5) if(!reset && dxFlag5) $display("dxFlag5: %d t: %d", dxFlag5, timer0);
always @(dxFlag6) if(!reset && dxFlag6) $display("dxFlag6: %d t: %d", dxFlag6, timer0);
always @(dxFlag7) if(!reset && dxFlag7) $display("dxFlag7: %d t: %d", dxFlag7, timer0);
always @(dxFlag8) if(!reset && dxFlag8) $display("dxFlag8: %d t: %d", dxFlag8, timer0);

always @(rxFlag0) if(!reset && rxFlag0) $display("rxFlag0: %d t: %d", rxFlag0, timer0);
always @(rxFlag1) if(!reset && rxFlag1) $display("rxFlag1: %d t: %d", rxFlag1, timer0);
always @(rxFlag2) if(!reset && rxFlag2) $display("rxFlag2: %d t: %d", rxFlag2, timer0);
always @(rxFlag3) if(!reset && rxFlag3) $display("rxFlag3: %d t: %d", rxFlag3, timer0);
always @(rxFlag4) if(!reset && rxFlag4) $display("rxFlag4: %d t: %d", rxFlag4, timer0);
always @(rxFlag5) if(!reset && rxFlag5) $display("rxFlag5: %d t: %d", rxFlag5, timer0);
always @(rxFlag6) if(!reset && rxFlag6) $display("rxFlag6: %d t: %d", rxFlag6, timer0);
always @(rxFlag7) if(!reset && rxFlag7) $display("rxFlag7: %d t: %d", rxFlag7, timer0);
always @(rxFlag8) if(!reset && rxFlag8) $display("rxFlag8: %d t: %d", rxFlag8, timer0);
//*/



/* Net Layer Module Testing
* 9 nodal net
*    ||   ||   ||
*  = N1 = N2 = N3 =
*    ||   ||   ||
*  = N4 = N5 = N6 =
*    ||   ||   ||
*  = N7 = N8 = N9 =
*    ||   ||   ||
* Connected as shown above
*********************************/
NLayer n0 (
	.CLK (CLK),
	.MRST (reset),	
	.rxFlag (rxFlag0),
	.dxFlag (dxFlag0),
	.dest_id (dest_ID0), 
	.send_data (send_data0),
	.nBusIn (nBusIn0),
	.sBusIn (nBusOut3),
	.eBusIn (wBusOut1),
	.wBusIn (wBusIn0),
	.nBusOut (nBusOut0),
	.sBusOut (sBusOut0),
	.eBusOut (eBusOut0),
	.wBusOut (wBusOut0),
	.idFlag	 (idFlag),
	.id		 (id0)
);

NLayer n1 (
	.CLK (CLK),
	.MRST (reset),	
	.rxFlag (rxFlag1),
	.dxFlag (dxFlag1),
	.dest_id (dest_ID1), 
	.send_data (send_data1),
	.nBusIn (nBusIn1),
	.sBusIn (nBusOut4),
	.eBusIn (wBusOut2),
	.wBusIn (eBusOut0),
	.nBusOut (nBusOut1),
	.sBusOut (sBusOut1),
	.eBusOut (eBusOut1),
	.wBusOut (wBusOut1),
	.idFlag	 (idFlag),
	.id		 (id1)
);

NLayer n2 (
	.CLK (CLK),
	.MRST (reset),	
	.rxFlag (rxFlag2),
	.dxFlag (dxFlag2),
	.dest_id (dest_ID2), 
	.send_data (send_data2),
	.nBusIn (nBusIn2),
	.sBusIn (sBusOut5),
	.eBusIn (eBusIn2),
	.wBusIn (eBusOut1),
	.nBusOut (nBusOut2),
	.sBusOut (sBusOut2),
	.eBusOut (eBusOut2),
	.wBusOut (wBusOut2),
	.idFlag	 (idFlag),
	.id		 (id2)
);

NLayer n3 (
	.CLK (CLK),
	.MRST (reset),	
	.rxFlag (rxFlag3),
	.dxFlag (dxFlag3),
	.dest_id (dest_ID3), 
	.send_data (send_data3),
	.nBusIn (sBusOut0),
	.sBusIn (nBusOut6),
	.eBusIn (wBusOut4),
	.wBusIn (wBusIn3),
	.nBusOut (nBusOut3),
	.sBusOut (sBusOut3),
	.eBusOut (eBusOut3),
	.wBusOut (wBusOut3),
	.idFlag	 (idFlag),
	.id		 (id3)
);

NLayer n4 (
	.CLK (CLK),
	.MRST (reset),	
	.rxFlag (rxFlag4),
	.dxFlag (dxFlag4),
	.dest_id (dest_ID4), 
	.send_data (send_data4),
	.nBusIn (sBusOut1),
	.sBusIn (nBusOut7),
	.eBusIn (wBusOut5),
	.wBusIn (eBusOut3),
	.nBusOut (nBusOut4),
	.sBusOut (sBusOut4),
	.eBusOut (eBusOut4),
	.wBusOut (wBusOut4),
	.idFlag	 (idFlag),
	.id		 (id4)
);

NLayer n5 (
	.CLK (CLK),
	.MRST (reset),	
	.rxFlag (rxFlag5),
	.dxFlag (dxFlag5),
	.dest_id (dest_ID5), 
	.send_data (send_data5),
	.nBusIn (sBusOut2),
	.sBusIn (nBusOut8),
	.eBusIn (eBusIn3),
	.wBusIn (eBusOut4),
	.nBusOut (nBusOut5),
	.sBusOut (sBusOut5),
	.eBusOut (eBusOut5),
	.wBusOut (wBusOut5),
	.idFlag	 (idFlag),
	.id		 (id5)
);

NLayer n6 (
	.CLK (CLK),
	.MRST (reset),	
	.rxFlag  (rxFlag6),
	.dxFlag  (dxFlag6),
	.dest_id (dest_ID6), 
	.send_data (send_data6),
	.nBusIn  (sBusOut3),
	.sBusIn  (sBusIn6),
	.eBusIn  (wBusOut7),
	.wBusIn  (wBusIn6),
	.nBusOut (nBusOut6),
	.sBusOut (sBusOut6),
	.eBusOut (eBusOut6),
	.wBusOut (wBusOut6),
	.idFlag	 (idFlag),
	.id		 (id6)
);


NLayer n7 (
	.CLK (CLK),
	.MRST (reset),	
	.rxFlag (rxFlag7),
	.dxFlag (dxFlag7),
	.dest_id (dest_ID7), 
	.send_data (send_data7),
	.nBusIn (sBusOut5),
	.sBusIn (sBusIn7),
	.eBusIn (wBusOut8),
	.wBusIn (eBusOut6),
	.nBusOut (nBusOut7),
	.sBusOut (sBusOut7),
	.eBusOut (eBusOut7),
	.wBusOut (wBusOut7),
	.idFlag	 (idFlag),
	.id		 (id7)
);


NLayer n8 (
	.CLK (CLK),
	.MRST (reset),	
	.rxFlag (rxFlag8),
	.dxFlag (dxFlag8),
	.dest_id (dest_ID8), 
	.send_data (send_data8),
	.nBusIn (sBusOut5),
	.sBusIn (sBusIn8),
	.eBusIn (eBusIn8),
	.wBusIn (eBusOut7),
	.nBusOut (nBusOut8),
	.sBusOut (sBusOut8),
	.eBusOut (eBusOut8),
	.wBusOut (wBusOut8),
	.idFlag	 (idFlag),
	.id		 (id8)
);



endmodule