// This only converts the actual code to an ASCII format,
// this is a simple decoder that is dumb to make/break codes
// or E0 complex codes  (ASCII only)
// the latter will be added when needed

// Usage Template:
//ScanCodeDecoder scd1(
//	.iScancode( ),
//	.iShiftEn ( ),
//	.oCharOut ( )
//);

module ScanCodeDecoder(
    iScancode,
    iShiftEn,
    oCharOut
);

input   wire    [7:0]   iScancode;
input   wire            iShiftEn;

output  wire    [7:0]   oCharOut;

// This just goes through an ASCII conversion LUT
// This could be optimized in the future by using a rom
// and a different decoder but since this is LUT is only
// 496 bits we can get away with it for now.

assign oCharOut = 	// Letters
					(iScancode == 8'h1C) ? ((iShiftEn) ?  8'h41 : 8'h61) :
					(iScancode == 8'h32) ? ((iShiftEn) ?  8'h42 : 8'h62) :
					(iScancode == 8'h21) ? ((iShiftEn) ?  8'h43 : 8'h63) :
					(iScancode == 8'h23) ? ((iShiftEn) ?  8'h44 : 8'h64) :
					(iScancode == 8'h24) ? ((iShiftEn) ?  8'h45 : 8'h65) :
					(iScancode == 8'h2B) ? ((iShiftEn) ?  8'h46 : 8'h66) :
					(iScancode == 8'h34) ? ((iShiftEn) ?  8'h47 : 8'h67) :
					(iScancode == 8'h33) ? ((iShiftEn) ?  8'h48 : 8'h68) :
					(iScancode == 8'h43) ? ((iShiftEn) ?  8'h49 : 8'h69) :
					(iScancode == 8'h3B) ? ((iShiftEn) ?  8'h4A : 8'h6A) :
					(iScancode == 8'h42) ? ((iShiftEn) ?  8'h4B : 8'h6B) :
					(iScancode == 8'h4B) ? ((iShiftEn) ?  8'h4C : 8'h6C) :
					(iScancode == 8'h3A) ? ((iShiftEn) ?  8'h4D : 8'h6D) :
					(iScancode == 8'h31) ? ((iShiftEn) ?  8'h4E : 8'h6E) :
					(iScancode == 8'h44) ? ((iShiftEn) ?  8'h4F : 8'h6F) :
					(iScancode == 8'h4D) ? ((iShiftEn) ?  8'h50 : 8'h70) :
					(iScancode == 8'h15) ? ((iShiftEn) ?  8'h51 : 8'h71) :
					(iScancode == 8'h2D) ? ((iShiftEn) ?  8'h52 : 8'h72) :
					(iScancode == 8'h1B) ? ((iShiftEn) ?  8'h53 : 8'h73) :
					(iScancode == 8'h2C) ? ((iShiftEn) ?  8'h54 : 8'h74) :
					(iScancode == 8'h3C) ? ((iShiftEn) ?  8'h55 : 8'h75) :
					(iScancode == 8'h2A) ? ((iShiftEn) ?  8'h56 : 8'h76) :
					(iScancode == 8'h1D) ? ((iShiftEn) ?  8'h57 : 8'h77) :
					(iScancode == 8'h22) ? ((iShiftEn) ?  8'h58 : 8'h78) :
					(iScancode == 8'h35) ? ((iShiftEn) ?  8'h59 : 8'h79) :
					(iScancode == 8'h1A) ? ((iShiftEn) ?  8'h5A : 8'h7A) :
					// Numbers
					(iScancode == 8'h45) ? 8'h30 :
					(iScancode == 8'h16) ? 8'h31 :
					(iScancode == 8'h1E) ? 8'h32 :
					(iScancode == 8'h26) ? 8'h33 :
					(iScancode == 8'h25) ? 8'h34 :
					(iScancode == 8'h2E) ? 8'h35 :
					(iScancode == 8'h36) ? 8'h36 :
					(iScancode == 8'h3D) ? 8'h37 :
					(iScancode == 8'h3E) ? 8'h38 :
					(iScancode == 8'h46) ? 8'h39 :
					// Enter
                    (iScancode == 8'h5A) ? 8'h0D :
                    // Space
                    (iScancode == 8'h29) ? 8'h20 :
                    // Back Space
                    (iScancode == 8'h66) ? 8'h08 :
					8'hFF;
endmodule
