// This is the network routing layer,  it basically acts transparently to the
// processor taking in an input message and dispatching or setting a flag to the 
// processor that a message is waiting in the stack

module NLayer(CLK, MRST, rxFlag, dxFlag
			  nBusIn, sBusIn, eBusIn, wBusIn
			  nBusOut, sBusOut, eBusOut, wBusOut );
input MRST;
input CLK;
input dxFlag;
output reg rxFlag;

// We have 4 directions (this is technically scalable)
input reg [0:31] nBusIn;
input reg [0:31] sBusIn;
input reg [0:31] eBusIn;
input reg [0:31] wBusIn;

output reg [0:31] nBusOut;
output reg [0:31] sBusOut;
output reg [0:31] eBusOut;
output reg [0:31] wBusOut;


// internal message counters for optimization
reg [0:7] n_cnt;
reg [0:7] s_cnt;
reg [0:7] e_cnt;
reg [0:7] w_cnt;

always @(posedge CLK) begin
	if(MRST) begin
		n_cnt <= 0;
		s_cnt <= 0;
		e_cnt <= 0;
		w_cnt <= 0;
		rxFlag <= 0;
	end
end



endmodule 