// Inputs an ASCII value and outputs a 9x

module ASCIIROM
(
    iCLK,
    iAddress,
    oCharBM
);
    // Inputs
    input iCLK;
    input[7:0] iAddress;

    // Outputs
    output reg[39:0] oCharBM;

    always@(posedge iCLK)
    begin
		case(iAddress)
			8'h00: oCharBM = {5'b00000,   // NULL
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h01: oCharBM = {5'b00000,   // Start of heading SOH
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h02: oCharBM = {5'b00000,   // Start of text STX
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h03: oCharBM = {5'b00000,   // End of text ETX
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h04: oCharBM = {5'b00000,  // End of transmition EOT
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h05: oCharBM = {5'b00000,   // Enquiry
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h06: oCharBM = {5'b00000,   // Acknowledge
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h07: oCharBM = {5'b00000,   // Bell
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h08: oCharBM = {5'b00000,   // Backspace
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h09: oCharBM = {5'b00000,   // Tab
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h0a: oCharBM = {5'b00000,   // New Line Feed
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h0b: oCharBM = {5'b00000,   // Vertical Tab
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h0c: oCharBM = {5'b00000,   // New page form feed
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h0d: oCharBM = {5'b00000,   // Carriage Return
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h0e: oCharBM = {5'b00000,   // Shift Out
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h0f: oCharBM = {5'b00000,   // Shift In
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h10: oCharBM = {5'b00000,   // Data Link Escape
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h11: oCharBM = {5'b00000,   // Device Control 1
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h12: oCharBM = {5'b00000,   // Device Control 2
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h13: oCharBM = {5'b00000,   // Device control 3
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h14: oCharBM = {5'b00000,   // Device Control 4
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h15: oCharBM = {5'b00000,   // Negative Acknowledge
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h16: oCharBM = {5'b00000,   // Syncronous Idle
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h17: oCharBM = {5'b00000,   // End of transmission. block
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h18: oCharBM = {5'b00000,   // Cancel
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h19: oCharBM = {5'b00000,   // End of medium
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h1a: oCharBM = {5'b00000,   // Substitute
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h1b: oCharBM = {5'b00000,   // Escape
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h1c: oCharBM = {5'b00000,   // File Seperator
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h1d: oCharBM = {5'b00000,   // Group Seperator
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h1e: oCharBM = {5'b00000,   // Record Seperator
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h1f: oCharBM = {5'b00000,   // Unit Seperator
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h20: oCharBM = {5'b00000,   // Space
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h21: oCharBM = {5'b00100,   // !
			                  5'b00100,
			                  5'b00100,
			                  5'b00100,
			                  5'b00100,
                              5'b00100,
                              5'b00000,
                              5'b00100
                             };
			8'h22: oCharBM = {5'b11011,   // "
			                  5'b11011,
			                  5'b10010,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h23: oCharBM = {5'b01010,   // #
			                  5'b01010,
			                  5'b11111,
			                  5'b01010,
			                  5'b01010,
                              5'b11111,
                              5'b01010,
                              5'b01010
                             };
			8'h24: oCharBM = {5'b00100,   // $
			                  5'b01110,
			                  5'b10101,
			                  5'b01100,
			                  5'b00110,
                              5'b10101,
                              5'b01110,
                              5'b00100
                             };
			8'h25: oCharBM = {5'b01000,   // %
			                  5'b10100,
			                  5'b01000,
			                  5'b00111,
			                  5'b11000,
                              5'b00010,
                              5'b00101,
                              5'b00010
                             };
			8'h26: oCharBM = {5'b01111,   // &
			                  5'b10000,
			                  5'b10000,
			                  5'b01110,
			                  5'b10100,
                              5'b10011,
                              5'b10010,
                              5'b01111
                             };
			8'h27: oCharBM = {5'b00100,   // '
			                  5'b00100,
			                  5'b00100,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h28: oCharBM = {5'b00100,   // (
			                  5'b00100,
			                  5'b01000,
			                  5'b01000,
			                  5'b01000,
                              5'b01000,
                              5'b00100,
                              5'b00100
                             };
			8'h29: oCharBM = {5'b00100,   // )
			                  5'b00100,
			                  5'b00010,
			                  5'b00010,
			                  5'b00010,
                              5'b00010,
                              5'b00100,
                              5'b00100
                             };
			8'h2a: oCharBM = {5'b00000,   // *
			                  5'b00100,
			                  5'b11111,
			                  5'b00100,
			                  5'b01010,
                              5'b01010,
                              5'b00000,
                              5'b00000
                             };
			8'h2b: oCharBM = {5'b00000,   // +
			                  5'b00000,
			                  5'b00100,
			                  5'b00100,
			                  5'b11111,
                              5'b00100,
                              5'b00100,
                              5'b00000
                             };
			8'h2c: oCharBM = {5'b00000,   // ,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00110,
                              5'b01110,
                              5'b01100,
                              5'b10000
                             };
			8'h2d: oCharBM = {5'b00000,   // -
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b11111,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h2e: oCharBM = {5'b00000,   // .
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b01100,
                              5'b01100
                             };
			8'h2f: oCharBM = {5'b00001,   // /
			                  5'b00001,
			                  5'b00010,
			                  5'b00100,
			                  5'b01000,
                              5'b01000,
                              5'b10000,
                              5'b10000
                             };
			8'h30: oCharBM = {5'b01110,    // 0 zero
			                  5'b10001,
			                  5'b10001,
			                  5'b10001,
			                  5'b10001,
                              5'b10001,
                              5'b10001,
                              5'b01110
                             };
			8'h31: oCharBM = {5'b00100,   // 1
			                  5'b11100,
			                  5'b00100,
			                  5'b00100,
			                  5'b00100,
                              5'b00100,
                              5'b00100,
                              5'b01110
                             };
			8'h32: oCharBM = {5'b01110,   // 2
			                  5'b10001,
			                  5'b10001,
			                  5'b00010,
			                  5'b00100,
                              5'b01000,
                              5'b10001,
                              5'b11111
                             };
			8'h33: oCharBM = {5'b01110,   // 3
			                  5'b10001,
			                  5'b00001,
			                  5'b01110,
			                  5'b00001,
                              5'b00001,
                              5'b10001,
                              5'b01110
                             };
			8'h34: oCharBM = {5'b00110,   // 4
			                  5'b01010,
			                  5'b10010,
			                  5'b11111,
			                  5'b00010,
                              5'b00010,
                              5'b00010,
                              5'b00111
                             };
			8'h35: oCharBM = {5'b11111,   // 5
			                  5'b10000,
			                  5'b10000,
			                  5'b11110,
			                  5'b00001,
                              5'b00001,
                              5'b10001,
                              5'b01110
                             };
			8'h36: oCharBM = {5'b01110,   // 6
			                  5'b10001,
			                  5'b10000,
			                  5'b11110,
			                  5'b10001,
                              5'b10001,
                              5'b10001,
                              5'b01110
                             };
			8'h37: oCharBM = {5'b11111,   // 7
			                  5'b10001,
			                  5'b00001,
			                  5'b00010,
			                  5'b00010,
                              5'b00100,
                              5'b00100,
                              5'b00100
                             };
			8'h38: oCharBM = {5'b01110,   // 8
			                  5'b10001,
			                  5'b10001,
			                  5'b01110,
			                  5'b10001,
                              5'b10001,
                              5'b10001,
                              5'b01110
                             };
			8'h39: oCharBM = {5'b01110,   // Nine
			                  5'b10001,
			                  5'b10001,
			                  5'b01111,
			                  5'b00001,
                              5'b00001,
                              5'b10001,
                              5'b01110
                             };
			8'h3a: oCharBM = {5'b00000,   // :
			                  5'b01100,
			                  5'b01100,
			                  5'b00000,
			                  5'b00000,
                              5'b01100,
                              5'b01100,
                              5'b00000
                             };
			8'h3b: oCharBM = {5'b00000,   // ;
			                  5'b0110,
			                  5'b01100,
			                  5'b00000,
			                  5'b00000,
                              5'b01100,
                              5'b11000,
                              5'b10000
                             };
			8'h3c: oCharBM = {5'b00000,   // <
			                  5'b00011,
			                  5'b01100,
			                  5'b10000,
			                  5'b01100,
                              5'b00011,
                              5'b00000,
                              5'b00000
                             };
			8'h3d: oCharBM = {5'b00000,   // =
			                  5'b00000,
			                  5'b11111,
			                  5'b00000,
			                  5'b11111,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h3e: oCharBM = {5'b00000,   // >
			                  5'b11000,
			                  5'b00110,
			                  5'b00001,
			                  5'b00110,
                              5'b11000,
                              5'b00000,
                              5'b00000
                             };
			8'h3f: oCharBM = {5'b01110,   // ?
			                  5'b10001,
			                  5'b00001,
			                  5'b00010,
			                  5'b00100,
                              5'b00100,
                              5'b00000,
                              5'b00100
                             };
			8'h40: oCharBM = {5'b01110,   // @
			                  5'b10001,
			                  5'b10011,
			                  5'b10101,
			                  5'b10111,
                              5'b10000,
                              5'b10001,
                              5'b01110
                             };
			8'h41: oCharBM = {5'b01110,   // Upper case A
			                  5'b10001,
			                  5'b10001,
			                  5'b11111,
			                  5'b10001,
                              5'b10001,
                              5'b10001,
                              5'b10001
                             };
			8'h42: oCharBM = {5'b11110,  // B
			                  5'b10001,
			                  5'b10001,
			                  5'b11110,
			                  5'b10001,
                              5'b10001,
                              5'b10001,
                              5'b11110
                             };
			8'h43: oCharBM = {5'b01111,   // C
			                  5'b10001,
			                  5'b10000,
			                  5'b10000,
			                  5'b10000,
                              5'b10000,
                              5'b10001,
                              5'b01110
                             };
			8'h44: oCharBM = {5'b11100,   // D
			                  5'b01010,
			                  5'b01001,
			                  5'b01001,
			                  5'b01001,
                              5'b01001,
                              5'b01010,
                              5'b11100
                             };
			8'h45: oCharBM = {5'b11111,   // E
			                  5'b10000,
			                  5'b10001,
			                  5'b11111,
			                  5'b10001,
                              5'b10000,
                              5'b10001,
                              5'b11111
                             };
			8'h46: oCharBM = {5'b11111,   // F
			                  5'b01001,
			                  5'b01000,
			                  5'b01110,
			                  5'b01000,
                              5'b01000,
                              5'b01000,
                              5'b11100
                             };
			8'h47: oCharBM = {5'b01111,   // G
			                  5'b10001,
			                  5'b10000,
			                  5'b10000,
			                  5'b10111,
                              5'b10010,
                              5'b10010,
                              5'b01100
                             };
			8'h48: oCharBM = {5'b11011,   // H
			                  5'b01010,
			                  5'b01010,
			                  5'b01110,
			                  5'b01010,
                              5'b01010,
                              5'b01010,
                              5'b11011
                             };
			8'h49: oCharBM = {5'b01110,   // I
			                  5'b00100,
			                  5'b00100,
			                  5'b00100,
			                  5'b00100,
                              5'b00100,
                              5'b00100,
                              5'b01110
                             };
			8'h4a: oCharBM = {5'b00111,   // J
			                  5'b00010,
			                  5'b00010,
			                  5'b00010,
			                  5'b00010,
                              5'b10010,
                              5'b10010,
                              5'b01100
                             };
			8'h4b: oCharBM = {5'b10000,   // K
			                  5'b10011,
			                  5'b10001,
			                  5'b10010,
			                  5'b10100,
                              5'b11100,
                              5'b10010,
                              5'b10001
                             };
			8'h4c: oCharBM = {5'b11100,   // L
			                  5'b01000,
			                  5'b01000,
			                  5'b01000,
			                  5'b01000,
                              5'b01000,
                              5'b01001,
                              5'b11111
                             };
			8'h4d: oCharBM = {5'b10001,   // M
			                  5'b11011,
			                  5'b10101,
			                  5'b10101,
			                  5'b10001,
                              5'b10001,
                              5'b10001,
                              5'b10001
                             };
			8'h4e: oCharBM = {5'b10001,   // N
			                  5'b11001,
			                  5'b10101,
			                  5'b10101,
			                  5'b10011,
                              5'b10011,
                              5'b10001,
                              5'b10001
                             };
			8'h4f: oCharBM = {5'b01110,   // O
			                  5'b10001,
			                  5'b10001,
			                  5'b10001,
			                  5'b10001,
                              5'b10001,
                              5'b10001,
                              5'b01110
                             };
			8'h50: oCharBM = {5'b11110,   // P
			                  5'b01001,
			                  5'b01001,
			                  5'b01110,
			                  5'b01000,
                              5'b01000,
                              5'b01000,
                              5'b11100
                             };
			8'h51: oCharBM = {5'b01110,   // Q
			                  5'b10001,
			                  5'b10001,
			                  5'b10001,
			                  5'b10001,
                              5'b10101,
                              5'b01110,
                              5'b00001
                             };
			8'h52: oCharBM = {5'b11110,   // R
			                  5'b01001,
			                  5'b01001,
			                  5'b01110,
			                  5'b01100,
                              5'b01100,
                              5'b01010,
                              5'b01001
                             };
			8'h53: oCharBM = {5'b01101,   // S
			                  5'b10011,
			                  5'b10001,
			                  5'b01000,
			                  5'b00110,
                              5'b00001,
                              5'b10001,
                              5'b01110
                             };
			8'h54: oCharBM = {5'b11111,   // T
			                  5'b10101,
			                  5'b00100,
			                  5'b00100,
			                  5'b00100,
                              5'b00100,
                              5'b00100,
                              5'b01110
                             };
			8'h55: oCharBM = {5'b10001,   // U
			                  5'b10001,
			                  5'b10001,
			                  5'b10001,
			                  5'b10001,
                              5'b10001,
                              5'b10001,
                              5'b01110
                             };
			8'h56: oCharBM = {5'b10001,   // V
			                  5'b10001,
			                  5'b10001,
			                  5'b01010,
			                  5'b01010,
                              5'b01010,
                              5'b01010,
                              5'b00100
                             };
			8'h57: oCharBM = {5'b10001,   // W
			                  5'b10001,
			                  5'b10001,
			                  5'b10001,
			                  5'b10101,
                              5'b10101,
                              5'b11011,
                              5'b10001
                             };
			8'h58: oCharBM = {5'b10001,   // X
			                  5'b10001,
			                  5'b01010,
			                  5'b00100,
			                  5'b00100,
                              5'b01010,
                              5'b10001,
                              5'b10001
                             };
			8'h59: oCharBM = {5'b10001,   // Y
			                  5'b10001,
			                  5'b01010,
			                  5'b00100,
			                  5'b00100,
                              5'b00100,
                              5'b00100,
                              5'b01110
                             };
			8'h5a: oCharBM = {5'b11111, // Uppercase Z
			                  5'b10001,
			                  5'b00010,
			                  5'b00100,
			                  5'b01000,
                              5'b10000,
                              5'b10001,
                              5'b11111
                             };
			8'h5b: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h5c: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h5d: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h5e: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h5f: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h60: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h61: oCharBM = {5'b00000,  // lower case a
			                  5'b00000,
			                  5'b01100,
			                  5'b10010,
			                  5'b01110,
                              5'b10010,
                              5'b10110,
                              5'b01011
                             };
			8'h62: oCharBM = {5'b11000, // b
			                  5'b01000,
			                  5'b01000,
			                  5'b01010,
			                  5'b01101,
                              5'b01001,
                              5'b01101,
                              5'b11010
                             };
			8'h63: oCharBM = {5'b00000, // c
			                  5'b00000,
			                  5'b00000,
			                  5'b01101,
			                  5'b10011,
                              5'b10000,
                              5'b10001,
                              5'b01110
                             };
			8'h64: oCharBM = {5'b00110, // d
			                  5'b00010,
			                  5'b00010,
			                  5'b01010,
			                  5'b10110,
                              5'b10010,
                              5'b10110,
                              5'b01011
                             };
			8'h65: oCharBM = {5'b00000, // e
			                  5'b00000,
			                  5'b00000,
			                  5'b01110,
			                  5'b10001,
                              5'b11111,
                              5'b10000,
                              5'b01111
                             };
			8'h66: oCharBM = {5'b00010, // f
			                  5'b00101,
			                  5'b00100,
			                  5'b00100,
			                  5'b01110,
                              5'b00100,
                              5'b00100,
                              5'b01110
                             };
			8'h67: oCharBM = {5'b00000, // g
			                  5'b00000,
			                  5'b01011,
			                  5'b10110,
			                  5'b10010,
                              5'b01110,
                              5'b00010,
                              5'b11100
                             };
			8'h68: oCharBM = {5'b11000, // h
			                  5'b01000,
			                  5'b01000,
			                  5'b01000,
			                  5'b01110,
                              5'b01001,
                              5'b01001,
                              5'b11001
                             };
			8'h69: oCharBM = {5'b00000, // i
			                  5'b00000,
			                  5'b00100,
			                  5'b00000,
			                  5'b01100,
                              5'b00100,
                              5'b00100,
                              5'b01110
                             };
			8'h6a: oCharBM = {5'b00000, // j
			                  5'b00000,
			                  5'b00100,
			                  5'b00000,
			                  5'b01100,
                              5'b00100,
                              5'b00100,
                              5'b1100
                             };
			8'h6b: oCharBM = {5'b00000, // k
			                  5'b11000,
			                  5'b01000,
			                  5'b01001,
			                  5'b01010,
                              5'b01100,
                              5'b01010,
                              5'b11001
                             };
			8'h6c: oCharBM = {5'b01100, // l
			                  5'b00100,
			                  5'b00100,
			                  5'b00100,
			                  5'b00100,
                              5'b00100,
                              5'b00100,
                              5'b01110
                             };
			8'h6d: oCharBM = {5'b00000, // m
			                  5'b00000,
			                  5'b00000,
			                  5'b10000,
			                  5'b11010,
                              5'b10101,
                              5'b10101,
                              5'b10101
                             };
			8'h6e: oCharBM = {5'b00000, // n
			                  5'b00000,
			                  5'b00000,
			                  5'b10110,
			                  5'b11001,
                              5'b10001,
                              5'b10001,
                              5'b10001
                             };
			8'h6f: oCharBM = {5'b00000, // o
			                  5'b00000,
			                  5'b00000,
			                  5'b01110,
			                  5'b10001,
                              5'b10001,
                              5'b10001,
                              5'b01110
                             };
			8'h70: oCharBM = {5'b00000, // p
			                  5'b00000,
			                  5'b11010,
			                  5'b01101,
			                  5'b01001,
                              5'b01110,
                              5'b01000,
                              5'b11100
                             };
			8'h71: oCharBM = {5'b00000, // q
			                  5'b00000,
			                  5'b01011,
			                  5'b10110,
			                  5'b10010,
                              5'b01110,
                              5'b00010,
                              5'b00111
                             };
			8'h72: oCharBM = {5'b00000, // r
			                  5'b00000,
			                  5'b10111,
			                  5'b01000,
			                  5'b01000,
                              5'b01000,
                              5'b01000,
                              5'b11100
                             };
			8'h73: oCharBM = {5'b00000, // s
			                  5'b00000,
			                  5'b0111,
			                  5'b10001,
			                  5'b01110,
                              5'b00001,
                              5'b10001,
                              5'b01110
                             };
			8'h74: oCharBM = {5'b00100, // t
			                  5'b00100,
			                  5'b01110,
			                  5'b00100,
			                  5'b00100,
                              5'b00100,
                              5'b00101,
                              5'b00010
                             };
			8'h75: oCharBM = {5'b00000, // u
			                  5'b00000,
			                  5'b10110,
			                  5'b10010,
			                  5'b10010,
                              5'b10010,
                              5'b10010,
                              5'b01101
                             };
			8'h76: oCharBM = {5'b00000, // v
			                  5'b00000,
			                  5'b00000,
			                  5'b10001,
			                  5'b10001,
                              5'b01010,
                              5'b01010,
                              5'b00100
                             };
			8'h77: oCharBM = {5'b00000, // w
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b10001,
                              5'b10101,
                              5'b10101,
                              5'b01010
                             };
			8'h78: oCharBM = {5'b00000, // x
			                  5'b00000,
			                  5'b00000,
			                  5'b10001,
			                  5'b01010,
                              5'b00100,
                              5'b01010,
                              5'b10001
                             };
			8'h79: oCharBM = {5'b00000,  // y
			                  5'b00000,
			                  5'b00000,
			                  5'b10001,
			                  5'b01010,
                              5'b00100,
                              5'b01000,
                              5'b10000
                             };
            8'h61: oCharBM = {5'b00000, // lower case z
			                  5'b00000,
			                  5'b00000,
			                  5'b11111,
			                  5'b00010,
                              5'b00100,
                              5'b01000,
                              5'b11111
                             };
            8'h7b: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h7c: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h7d: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h7e: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h7f: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h80: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h81: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h82: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h83: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h84: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h85: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h86: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h87: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h88: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h89: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h8a: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h8b: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h8c: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h8d: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h8e: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h8f: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h90: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h91: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h92: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h93: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h94: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h95: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h96: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h97: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h98: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h99: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h9a: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h9b: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h9c: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h9d: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h9e: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'h9f: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'ha0: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'ha1: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'ha2: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'ha3: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'ha4: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'ha5: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'ha6: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'ha7: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'ha8: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'ha9: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'haa: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hab: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hac: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'had: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hae: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'haf: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hb0: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hb1: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hb2: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hb3: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hb4: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hb5: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hb6: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hb7: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hb8: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hb9: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hba: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hbb: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hbc: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hbd: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hbe: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hbf: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hc0: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hc1: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hc2: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hc3: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hc4: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hc5: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hc6: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hc7: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hc8: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hc9: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hca: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hcb: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hcc: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hcd: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hce: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hcf: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hd0: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hd1: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hd2: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hd3: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hd4: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hd5: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hd6: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hd7: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hd8: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hd9: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hda: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hdb: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hdc: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hdd: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hde: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hdf: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'he0: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'he1: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'he2: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'he3: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'he4: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'he5: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'he6: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'he7: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'he8: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'he9: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hea: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'heb: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hec: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hed: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hee: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hef: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hf0: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hf1: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hf2: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hf3: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hf4: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hf5: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hf6: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hf7: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hf8: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hf9: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hfa: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hfb: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hfc: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hfd: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hfe: oCharBM = {5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
			                  5'b00000,
                              5'b00000,
                              5'b00000,
                              5'b00000
                             };
			8'hff: oCharBM = {5'b11111,
			                  5'b11111,
			                  5'b11111,
			                  5'b11111,
			                  5'b11111,
                              5'b11111,
                              5'b11111,
                              5'b11111
                             };
        endcase
    end
endmodule
